---
name: "tor-linux"
suites:
- "lucid"
architectures:
- "i386"
- "amd64"
packages: 
- "git-core"
- "unzip"
- "zip"
- "autoconf"
- "autoconf2.13"
- "automake"
- "faketime"
- "libtool"
- "hardening-wrapper"
- "zlib1g-dev"
reference_datetime: "2000-01-01 00:00:00"
remotes:
- "url": "https://git.torproject.org/tor.git"
  "dir": "tor"
- "url": "https://github.com/libevent/libevent.git"
  "dir": "libevent"
files:
- "bug10297.patch"
- "bug5018.patch"
- "dzip.sh"
- "openssl.tar.gz"
script: |
  INSTDIR="$HOME/install"
  export LIBRARY_PATH="$INSTDIR/lib"
  export LD_PRELOAD=/usr/lib/faketime/libfaketime.so.1
  export FAKETIME=$REFERENCE_DATETIME
  export TZ=UTC
  export LC_ALL=C
  umask 0022
  #
  # Config options for hardening-wrapper
  export DEB_BUILD_HARDENING=1
  export DEB_BUILD_HARDENING_STACKPROTECTOR=1
  export DEB_BUILD_HARDENING_FORTIFY=1
  export DEB_BUILD_HARDENING_FORMAT=1
  export DEB_BUILD_HARDENING_PIE=1
  #
  mkdir -p $INSTDIR/Data/Tor/
  mkdir -p $INSTDIR/Tor/
  mkdir -p $INSTDIR/Debug/Tor/
  #
  cd libevent
  ./autogen.sh
  find -type f | xargs touch --date="$REFERENCE_DATETIME"
  ./configure --disable-static --prefix=$INSTDIR/libevent
  make $MAKEOPTS
  make install
  cp $INSTDIR/libevent/lib/libevent-2.0.so.5 $INSTDIR/Tor/
  cd ..
  #
  tar xzf openssl.tar.gz
  cd openssl-*
  find -type f | xargs touch --date="$REFERENCE_DATETIME"
  #./Configure -shared --prefix=$INSTDIR/openssl linux-elf
  ./config -shared --prefix=$INSTDIR/openssl #enable-ec_nistp_64_gcc_128
  make
  make install
  cp $INSTDIR/openssl/lib/libssl.so.1.0.0 $INSTDIR/Tor/
  cp $INSTDIR/openssl/lib/libcrypto.so.1.0.0 $INSTDIR/Tor/
  cd ..
  #
  chmod 700 $INSTDIR/Tor/*so*
  #
  cd tor
  git update-index --refresh -q
  export GIT_COMMITTER_NAME="nobody"
  export GIT_COMMITTER_EMAIL="nobody@localhost"
  export GIT_COMMITTER_DATE="$REFERENCE_DATETIME"
  git am ~/build/bug10297.patch
  git am ~/build/bug5018.patch
  mkdir -p $OUTDIR/src
  #git archive HEAD | tar -x -C $OUTDIR/src
  ./autogen.sh
  find -type f | xargs touch --date="$REFERENCE_DATETIME"
  ./configure --disable-asciidoc --with-libevent-dir=$INSTDIR/libevent --with-openssl-dir=$INSTDIR/openssl --prefix=$INSTDIR
  make $MAKEOPTS
  make install
  cp $INSTDIR/share/tor/geoip $INSTDIR/Data/Tor/
  # Strip and generate debuginfo for libs
  cd $INSTDIR
  objcopy --only-keep-debug $INSTDIR/bin/tor $INSTDIR/Debug/Tor/tor
  install -s $INSTDIR/bin/tor $INSTDIR/Tor/
  objcopy --add-gnu-debuglink=./Debug/Tor/tor $INSTDIR/Tor/tor
  for i in $INSTDIR/Tor/*so*
  do
    LIB=`basename $i`
    objcopy --only-keep-debug $INSTDIR/Tor/$LIB $INSTDIR/Debug/Tor/$LIB
    strip $INSTDIR/Tor/$LIB
    objcopy --add-gnu-debuglink=./Debug/Tor/$LIB $INSTDIR/Tor/$LIB
  done
  #
  ~/build/dzip.sh tor-linux$GBUILD_BITS-gbuilt.zip Data/ Tor/
  ~/build/dzip.sh tor-linux$GBUILD_BITS-debug.zip Debug/
  cp tor-linux$GBUILD_BITS-gbuilt.zip $OUTDIR/
  cp tor-linux$GBUILD_BITS-debug.zip $OUTDIR/
